unit CliSheet;

interface

uses
  {$IFDEF WIN32} Windows,
  {$ELSE}        WinTypes, WinProcs,
  {$ENDIF}
  Sysutils, Classes, Forms, Controls, Buttons, StdCtrls, SomeType, ExtCtrls;

type

  { TfrmClient }
  TfrmClient = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure Screen2Client;
  protected
    { Private declarations }
    constructor Clone(AOwner: TComponent; AClient: TClient);
  public
    { Public declarations }
    Client: TClient;
  end;

function GetNewClient(AOwner: TComponent): TClient;
function EditNewClient(AOwner: TComponent; AClient: TClient): Boolean;

implementation

{$R *.DFM}

function GetNewClient(AOwner: TComponent): TClient;
begin
  Result := nil;
  with TfrmClient.Create(AOwner) do
  try
    if ShowModal = mrOk then
      Result := Client;
  finally
    Free;
  end;
end;

function EditNewClient(AOwner: TComponent; AClient: TClient): Boolean;
begin
  with TfrmClient.Clone(AOwner, AClient) do
  try
    Result := ShowModal = mrOk;
  finally
    Free;
  end;
end;

procedure TfrmClient.FormCreate(Sender: TObject);
begin
  Client := nil;
end;

constructor TfrmClient.Clone(AOwner: TComponent; AClient: TClient);
begin
  inherited Create(AOwner);
  Client := AClient;
  with Client do
  begin
    Edit1.Text := Name;
    Edit2.Text := Phone;
    Edit3.Text := EMail;
    Edit4.Text := WebSite;
    Edit5.Text := IntToStr(Age);
  end;
end;

procedure TfrmClient.Screen2Client;
begin
  if not Assigned(Client) then Exit
  else
    with Client do
    begin
      Name := Edit1.Text;
      Phone := Edit2.Text;
      EMail := Edit3.Text;
      WebSite := Edit4.Text;
      Age := StrToInt(Edit5.Text);
    end;
end;

procedure TfrmClient.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := ModalResult = mrCancel;
  if not CanClose then
  begin
    if Edit1.Text = '' then
    begin
      Application.MessageBox('This field is required','Warning', MB_OK);
      Edit1.SetFocus;
      Exit;
    end;
    try
      Screen2Client;
      if not Assigned(Client) then
        Client := TClient.Create(Edit1.Text, Edit2.Text, Edit3.Text, Edit4.Text, StrToInt(Edit5.Text));
      CanClose := True;
    except
      Raise;
    end;
  end;
end;

end.

