unit FindStuf;

interface

uses
  {$IFDEF WIN32} Windows,
  {$ELSE}        WinTypes,
  {$ENDIF}
  SysUtils, Forms, StdCtrls, Buttons, ExtCtrls, Classes, Controls, LongColl, SomeType,
  Spin;

type

  { TfrmArcOption }
  TfrmQuery = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    chkName: TCheckBox;
    chkPhone: TCheckBox;
    chkEMail: TCheckBox;
    chkWebSite: TCheckBox;
    Label2: TLabel;
    btnFirst: TButton;
    btnLast: TButton;
    btnNext: TButton;
    Label3: TLabel;
    cbxWhat: TComboBox;
    cbxSign: TComboBox;
    edtspin: TSpinEdit;
    Bevel1: TBevel;
    Label4: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    List: TClientCollection;
    function Query(C: TClient): Boolean;
  protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure EnableChekcs(Enable: Boolean);
  public
    { Public declarations }
  end;

procedure ExecQuery(AOwner: TComponent; AList: TClientCollection);

implementation

{$R *.DFM}

uses
  SDIMain;

var
  Already: Boolean;
  frmQuery: TfrmQuery;

procedure ExecQuery(AOwner: TComponent; AList: TClientCollection);
begin
  if Already then Exit;
  frmQuery := TfrmQuery.Create(AOwner);
  with frmQuery do
  begin
    List := AList;
    Show;
  end;
  Already := True;
end;

procedure TfrmQuery.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    WndParent := TForm(Owner).Handle;
    Style := Style or ws_DlgFrame;
  end;
end;

procedure TfrmQuery.FormCreate(Sender: TObject);
begin
  cbxWhat.ItemIndex := 0;
  cbxSign.ItemIndex := 1;
end;

procedure TfrmQuery.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then Close;
end;

procedure TfrmQuery.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmQuery.FormDestroy(Sender: TObject);
begin
  Already := False;
  SDIAppForm.UpdateMenu;
end;

procedure TfrmQuery.EnableChekcs(Enable: Boolean);
begin
  chkName.Enabled := Enable;
  chkPhone.Enabled := Enable;
  chkEMail.Enabled := Enable;
  chkWebSite.Enabled := Enable;
end;

procedure TfrmQuery.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  EnableChekcs((Edit1.Text <> '') or not (Key in [VK_BACK,VK_DELETE]));
end;

function TfrmQuery.Query(C: TClient): Boolean;
var
  Temp: Boolean;
begin
  Result := (Edit1.Text <> '') and
            ((chkName.Checked and (Pos(Edit1.Text, C.Name) > 0)) or
             (chkPhone.Checked and (Pos(Edit1.Text, C.Phone) > 0)) or
             (chkEMail.Checked and (Pos(Edit1.Text, C.EMail) > 0)) or
             (chkWebSite.Checked and (Pos(Edit1.Text, C.WebSite) > 0)));
  if cbxWhat.ItemIndex = 0 then Exit;
  Result := Result or (not chkName.Checked and
                       not chkPhone.Checked and
                       not chkEMail.Checked and
                       not chkWebSite.Checked);
  case cbxSign.ItemIndex of
    {<}0: Temp := C.CompareAge(StrToInt(edtSpin.Text)) < 0;
    {=}1: Temp := C.CompareAge(StrToInt(edtSpin.Text)) = 0;
    {>}2: Temp := C.CompareAge(StrToInt(edtSpin.Text)) > 0;
  end;
  case cbxWhat.ItemIndex of
    {and} 1: Result := Result AND Temp;
    {or}  2: Result := Result OR  Temp;
  end;
end;

procedure TfrmQuery.btnFindClick(Sender: TObject);

function Condition(C: TClient): Boolean; far;
begin
  Result := Query(C);
end;

var
  Client: TClient;
begin
  if Sender = btnFirst then
    Client := List.FirstThat(@Condition)
  else
    Client := List.LastThat(@Condition);
  if Assigned(Client) then
    SDIAppForm.UpdateListBoxIndex(List.Curr)
  else
    SDIAppForm.UpdateListBoxIndex(-1);
end;

procedure TfrmQuery.btnNextClick(Sender: TObject);
function Condition(C: TClient): Boolean; far;
begin
  Result := Query(C);
end;

var
  Client: TClient;
begin
  Client := List.NextThat(@Condition);
  if Assigned(Client) then
    SDIAppForm.UpdateListBoxIndex(List.Curr)
  else
    SDIAppForm.UpdateListBoxIndex(-1);
end;

procedure TfrmQuery.Button1Click(Sender: TObject);
var
  NewAge: Longint;

procedure DoChangeAge(C: TClient); far;
begin
  C.Age := NewAge;
end;

begin
  try
    NewAge := StrToInt(Edit2.Text);
  except
    NewAge := 0;
  end;
  List.ForEach(@DoChangeAge);
  SDIAppForm.UpdateListBox;
end;

initialization
  Already := False;
end.

