unit Fields;

interface

uses
  {$IFDEF WIN32} Windows,
  {$ELSE}        WinTypes, WinProcs,
  {$ENDIF}
  SysUtils, Classes, Forms, Graphics, Controls, Buttons, StdCtrls,
  RecTypes;

type

  { TdlgField }
  TdlgField = class(TForm)
    btnOk: TBitBtn;
    CancelBtn: TBitBtn;
    grpField: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtName: TEdit;
    cbxType: TComboBox;
    chkPublished: TCheckBox;
    Label3: TLabel;
    cbxObjectName: TComboBox;
    procedure checkEntry(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbxTypeClick(Sender: TObject);
    procedure cbxObjectNameChange(Sender: TObject);
    procedure cbxObjectNameExit(Sender: TObject);
  private
    { Private declarations }
    procedure EnableIt(Enable: Boolean);
  public
    { Public declarations }
    procedure SetFields(AName, AType: String; APublished: Boolean);
    constructor Create(AOwner: TComponent; cbx: TComboBox);
  end;

implementation

{$R *.DFM}

constructor TdlgField.Create(AOwner: TComponent; cbx: TComboBox);
begin
  inherited Create(AOwner);
  cbxObjectName.Items.Assign(cbx.Items);
end;

procedure TdlgField.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to StrToInt(LoadStr(5)) - 1 do
    cbxType.Items.Add(LoadStr(100+I));
end;

procedure TdlgField.checkEntry(Sender: TObject);
begin
  btnOk.Enabled := (edtName.Text <> '') and
                   (cbxType.ItemIndex <> -1) and
                   ((cbxType.ItemIndex < ord(trObject)) or
                    (cbxObjectName.Text <> ''));
  EnableIt(cbxType.ItemIndex = ord(trObject));
end;

procedure TdlgField.cbxTypeClick(Sender: TObject);
begin
  EnableIt(cbxType.ItemIndex = ord(trObject));
end;

procedure TdlgField.SetFields(AName, AType: String; APublished: Boolean);
begin
  edtName.Text := AName;
  cbxType.ItemIndex := cbxType.Items.IndexOf(AType);
  chkPublished.Checked := APublished;
end;

procedure TdlgField.EnableIt(Enable: Boolean);
begin
  cbxObjectName.Enabled := Enable;
  if Enable then
    cbxObjectName.Color := clWindow
  else
    cbxObjectName.Color := clBtnFace;
end;

procedure TdlgField.cbxObjectNameChange(Sender: TObject);
begin
  btnOk.Enabled := (edtName.Text <> '') and
                    (cbxType.ItemIndex <> -1) and
                    ((cbxType.ItemIndex < ord(trObject)) or
                    (cbxObjectName.Text <> ''));
end;

procedure TdlgField.cbxObjectNameExit(Sender: TObject);
begin
  if cbxObjectName.Text <> '' then
    if cbxObjectName.Items.IndexOf(cbxObjectName.Text) = -1 then
      cbxObjectName.Items.Add(cbxObjectName.Text);
end;

end.

