unit Unit2;

interface

uses
  {$IFDEF WIN32} Windows,
  {$ELSE}        WinTypes,
  {$ENDIF}
  Forms, LongColl, GraphObj;

type
  TForm2 = class(TForm)
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    GraphList: TCollection32;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.FormShow(Sender: TObject);
var
  GraphStream: TDStream;
begin
  GraphList := nil;
  try
    GraphStream := TDStream.Create('GRAPH.STM', of_Read, 8192); { Open stream     }
    GraphList := TCollection32(GraphStream.Get);          { Load collection }
    GraphStream.Free;                                     { Free stream     }
  except
    Application.MessageBox('Run "stream" project first, to create collection.', 'Error', MB_OK);
  end;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  if Assigned(GraphList) then
    GraphList.Free;                                       { Free collection }
end;

procedure TForm2.FormPaint(Sender: TObject);

procedure CallDraw(P: TGraphObject); far;
begin
  P.Draw(Form2.Canvas.Handle); { Call Draw method }
end;

begin
  if Assigned(GraphList) then
    GraphList.ForEach(@CallDraw);
end;

end.

